package com.example.ellegadodepintia.exploradoresDePintia.model.eventoFactory

import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.Atributo
import com.example.ellegadodepintia.exploradoresDePintia.model.Opcion
import com.example.ellegadodepintia.exploradoresDePintia.model.efecto.EfectoIgnorar
import com.example.ellegadodepintia.exploradoresDePintia.model.efecto.EfectoNubeVaccea

class DescansoFactory : EventoFactory {
    private val descansosMap = mapOf(
        "Llegaste a un campamento vacceo, con un gran fuego en el centro y chozas hechas de madera y barro. Aquí puedes descansar, recuperar energía y estar listo para nuevas aventuras." to Pair(
            R.drawable.asi_exploradores_campamento, listOf(
                Opcion(
                    descripcion = "Descansar",
                    atributoRequerida = Atributo.Energia,
                    EfectoNubeVaccea()

                ), Opcion(
                    descripcion = "Continuar",
                    atributoRequerida = Atributo.Nula,
                    EfectoIgnorar(100)
                )
            )
        )
    )

    override fun generarDescripcion(): String {
        return descansosMap.keys.random()
    }

    override fun generarOpciones(descripcion: String): MutableList<Opcion> {
        return descansosMap[descripcion]?.second?.toMutableList()
            ?: mutableListOf()
    }

    override fun generarImagen(descripcion: String): Int {
        return descansosMap[descripcion]?.first!!
    }

    override fun generarEvento(): EventoDescanso {
        val descripcion = generarDescripcion()
        return EventoDescanso(
            descripcion = descripcion,
            dificultad = 0,
            opciones = generarOpciones(descripcion),
            imagen = generarImagen(descripcion),
            resistenciaMax = (2..8).random(),
            finalizado = false
        )
    }
}