package com.example.ellegadodepintia.exploradoresDePintia.model.eventoFactory

import com.example.ellegadodepintia.exploradoresDePintia.model.GestorDeEventos
import com.example.ellegadodepintia.exploradoresDePintia.model.Opcion

abstract class Evento(
    open val descripcion: String,
    open val dificultad: Int,
    open val opciones: MutableList<Opcion>,
    open val imagen: Int,
    val resistenciaMax: Int,
    open var resistenciaActual: Int,
    open var finalizado : Boolean
){
    private val observers = mutableListOf<(Evento) -> Unit>()

    fun actualizarFinalizado(finalizado : Boolean){
        this.finalizado = finalizado
        GestorDeEventos.mostrarOpcionElegirCamino()
    }

    fun addObserver(observer: (Evento) -> Unit) {
         observers.add(observer)
    }

    fun actualizarResistencia(valor : Int){
        resistenciaActual += valor
        notifyObservers()
    }

    private fun notifyObservers() {
        observers.forEach { it(this) }
    }


    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other == null || javaClass != other.javaClass) return false
        other as Evento
        return descripcion == other.descripcion
    }

    override fun hashCode(): Int {
        return descripcion.hashCode()
    }


}
